#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void primer_citaj_znak_po_znak(char* ime_datoteke);
void primer_citaj_liniju_po_liniju(char* ime_datoteke);
void upisi_u_fajl(char* ime_datoteke);
void prebacivanje(char* datoteka);
void prebacivanje_taraba(char* datoteka);
char* formiraj_string_cifara(char* str_ulaz);
int da_li_je_cifra(char ch);

int main() {
	//primer_citaj_znak_po_znak("ulaz.txt");
	//primer_citaj_znak_po_znak("c:\\cdat\\ulaz.txt");

	//primer_citaj_liniju_po_liniju("ulaz.txt");

	//upisi_u_fajl("ulaz.txt");
	//primer_citaj_liniju_po_liniju("ulaz.txt");

	//prebacivanje("ulaz.txt", "izlaz.txt");
	//primer_citaj_liniju_po_liniju("izlaz.txt");

	//prebacivanje_taraba("ulaz.txt", "izlaz.txt");
	
	
	char* str=formiraj_string_cifara("5sad5102 21asd 049a");
	printf("%s", str);

	system("pause");
	return 0;
}

void primer_citaj_znak_po_znak(char* ime_datoteke) {
	FILE* datoteka;
	
	datoteka=fopen(ime_datoteke, "r"); //"r" otvara tekstualnu datoteku za citanje
	if (datoteka == NULL) {
		printf("\nDatoteka ne postoji %s", ime_datoteke);
	}
	else {
		printf("\nDatoteka postoji. Sadrzaj datoteke je: %s\n", ime_datoteke);
		/*while (1) {
			char c = fgetc(datoteka);
			if (c == EOF) break;
			printf("%c", c);
		}*/

		/*char c = fgetc(datoteka);
		while (c != EOF) {
			printf("%c", c);
			c = fgetc(datoteka);
		}*/
		
		char c;
		while ((c=fgetc(datoteka))!=EOF){
			printf("%c", c);
		}
		fclose(datoteka); //zatvaranje datoteke
	}
}

void primer_citaj_liniju_po_liniju(char* ime_datoteke) {
	FILE* datoteka;
	char str[100];
	int linija = 0;
	datoteka = fopen(ime_datoteke, "r");
	if (datoteka != NULL) {
		printf("\nDatoteka postoji. Sadrzaj datoteke je: %s\n", ime_datoteke);
		while(fgets(str, 100, datoteka)!=NULL){
			printf("%d: %s", ++linija, str);
		}
		fclose(datoteka);
	}
	else {
		printf("datoteka ne postoji %s", ime_datoteke);
	}
}

void upisi_u_fajl(char* ime_datoteke) {
	FILE* datoteka;
	int n;
	char str[100];
	
	datoteka = fopen(ime_datoteke, "w");//"w" oznacava mod upisivanja u datoteku
	
	printf("Koliko linija zelis da uneses "); 
	scanf("%d", &n);
	getchar(); //prima enter od scanf-a
	for (int i = 1; i <= n; i++) {
		printf("%d: ", i);
		gets(str);
		//printf("\nKorisnik je uneo: %s", str);
		fputs(str, datoteka); //upisivanje stringa u datoteku
		fputs("\n", datoteka);
	}
	
	fclose(datoteka);
}

void prebacivanje(char* ulazna_datoteka, char* izlazna_datoteka) {
	FILE* datoteka_ulaz;
	FILE* datoteka_izlaz;
	
	datoteka_ulaz = fopen(ulazna_datoteka, "r");
	datoteka_izlaz = fopen(izlazna_datoteka, "w");

	char ch;
	while ((ch = fgetc(datoteka_ulaz)) != EOF) {
		if (ch != ' ') { //cita znak ako nije space
			fputc(ch, datoteka_izlaz);
		}
	}
	fclose(datoteka_izlaz);
	fclose(datoteka_ulaz);
}

void prebacivanje_taraba(char* ulazna_datoteka, char* izlazna_datoteka) {
	FILE* datoteka_ulaz;
	FILE* datoteka_izlaz;

	datoteka_ulaz = fopen(ulazna_datoteka, "r");
	datoteka_izlaz = fopen(izlazna_datoteka, "w");

	char ch, taraba;
	taraba = '#';
	while ((ch = fgetc(datoteka_ulaz)) != EOF) {
		if (ch != ' ') { //cita znak ako nije space
			fputc(ch, datoteka_izlaz);
			taraba = '#';
		}
		else {
			//da li da ga upisem
			if (taraba == '#') {
				fputc(taraba, datoteka_izlaz);
				taraba = ' ';//ovde je vazno da je postavimo da je bilo sta osim #
			}
		}
	}
	fclose(datoteka_izlaz);
	fclose(datoteka_ulaz);
}

char* formiraj_string_cifara(char* str_ulaz) {
	char* str_izlaz;
	int brel = strlen(str_ulaz);
	int n = 0;//broj elemenata u izlaznom stringu
	str_izlaz = (char*)malloc((brel+1) * sizeof(char));//rezervisi brel+1 memorijskih lokacija velicine char za str_izlaz
	
	for (int i = 0; i < brel; i++) {
		//printf("%c", str_ulaz[i]);
		if (da_li_je_cifra(str_ulaz[i])==1) {
			str_izlaz[n] = str_ulaz[i];
			n++;
		}
	}
	str_izlaz[n] = '\0';
	

	return str_izlaz;
}

int da_li_je_cifra(char ch) {
	if ((ch - '0' >= 0) && (ch - '0' <= 9)) return 1;
	return 0;
}